//
// Added 13/11/2014 9:29:06 AM
//
// action  READ_OBJ, WRITE_OBJ, WRITE_MAGIC_BYTES or WRITE_MAGIC_DBYTES
// object  Usually the object number, but since you can call this routing inside your code you could change this
// newVal  New value for WRITE_OBJ. Length for WRITE_MAGIC_BYTES and WRITE_MAGIC_DBYTES
// ptr     poiinter to data for WRITE_MAGIC_BYTES and WRITE_MAGIC_DBYTES, otherwise N/A
//
#CONST
    MFILE_READ
    MFILE_WRITE
    MFILE_APPEND
    MFILE_ERASE
    MFILE_DIR
    MFILE_SCREEN_CAPTURE
    MFILE_SIZE
#END
//

func rMagicObject0(var action, var object, var newVal, var *ptr)
    var fname, cmd, i, j, k, myhndl, szh, szl, szlo, fdata[7] ;
    if (action == WRITE_MAGIC_BYTES)
        for (i := 1; i < newVal; i++)           // change endianness
            j := i*2 ;
            ptr[i] := (ptr[j] << 8) + ptr[j-1] ;
        next
        cmd   := ptr[0] ;                       // extract command
        fname := str_Ptr(&ptr[1]) ;             // build string pointer
//        print(cmd," ") ;
//        str_Printf(&fname, "%s\n");             // fname will need restting afterwards
//        fname := str_Ptr(&ptr[1]) ;             // to reset
        seroutCS(REPORT_MAGIC_EVENT_BYTES) ;    // we report in bytes
        seroutCS(object) ;
        switch (cmd)
            case MFILE_READ :
                myhndl := file_Open(fname, 'r') ;
                if (!myhndl)                    // check for error
                    seroutCS(1) ;               // 0 length to show error
                    seroutCS(cmd) ;             // echo command code to assist the master
                else                            // output consists of 00 (for last or only 'block', or ff for more blocks to come
                    file_Size(myhndl,&szh, &szl) ;
                    repeat
                        if (   (szh != 0)
                            || (szl > 253)
                            || (szl < 0)  )
                            seroutCS(255) ;
                            seroutCS(cmd) ;         // echo command code to assist the master
                            seroutCS(0xFF) ;
                            j := 253 ;
                            k := 1 ;
                        else
                            seroutCS(szl+2) ;
                            seroutCS(cmd) ;         // echo command code to assist the master
                            seroutCS(0) ;
                            j := szl ;
                            k := 0 ;
                        endif
                        for (i := 0; i < j; i++)
// while(com_TXcount() > 90) ;     // circumvent PmmC bug prior to R43(Picaso) or R16(Diablo)
                            seroutCS(file_GetC(myhndl));
                            pause(5);
                        next

                        szlo := szl ;
                        szl -= j ;
                        if ((szl < 0) && (szlo >= 0))
                            szh-- ;
                        endif
                        if (k)
                            seroutOcs() ;
                            seroutCS(REPORT_MAGIC_EVENT_BYTES) ;    // we report in bytes
                            seroutCS(object) ;
                        endif
                        pause(1000);      // insert to give time for the host to "process" the previous message
                    until ((szl == 0) && (szh == 0)) ;
                endif
                break ;
            case MFILE_WRITE :
            case MFILE_APPEND :
                if (cmd == MFILE_WRITE)
                    myhndl := file_Open(fname, 'w') ;
                else
                    myhndl := file_Open(fname, 'a') ;
                endif
                if (!myhndl)                    // check for error
                    seroutCS(1) ;               // 1 length to show error
                    seroutCS(cmd) ;             // echo command code to assist the master
                else                            // output consists of 00 (for last or only 'block', or ff for more blocks to come
                    i := str_Length(fname) ;
                    seroutCS(2) ;
                    seroutCS(cmd) ;             // echo command code to assist the master
                    file_Write(str_Ptr(ptr) + i + 3, newVal-i-2, myhndl) ;
                    seroutCS(file_Close(myhndl));
                endif
                break ;
            case MFILE_ERASE :
                seroutCS(2) ;                       // response is 1 byte
                seroutCS(cmd) ;                     // echo command code to assist the master
                seroutCS(file_Erase(fname)) ;
                break ;
            case MFILE_DIR :
                i := 999 ;
                while(i)
                    to(fdata) ;
                    if (i == 999)
                        i := file_FindFirst(fname);
                    else
                        i := file_FindNext() ;
                    endif
//while(com_TXcount() > 70) ;     // circumvent PmmC bug prior to R43(Picaso) or R16(Diablo)
                    if(!i) fdata[0] := 0 ;                      // zero out response in case of 'fail'
                    seroutCS(strlen(fdata)+1) ;
                    seroutCS(cmd) ;                             // echo command code to assist the master
                    j := str_Ptr(fdata) ;
                    while  (k := str_GetByte(j++))
                        seroutCS(k) ;
                    wend
                    if (i)
                        seroutOcs() ;
                        seroutCS(REPORT_MAGIC_EVENT_BYTES) ;    // we report in bytes
                        seroutCS(object) ;
                    endif
                wend
                break ;
            case MFILE_SCREEN_CAPTURE :
                file_Erase(fname) ;
                myhndl := file_Open(fname, 'w') ;
                seroutCS(2) ;                   // response is 2 bytes
                seroutCS(cmd) ;                 // echo command code to assist the master
                if (!myhndl)                    // check for error
                    seroutCS(1) ;               // 1 show error
                    seroutCS(cmd) ;             // echo command code to assist the master
                else
                    file_ScreenCapture(0, 0, gfx_Get(X_MAX)+1, gfx_Get(Y_MAX)+1, myhndl);
                    seroutCS(file_Close(myhndl));
                endif
                break ;
            case MFILE_SIZE :
                myhndl := file_Open(fname, 'r') ;
                if (!myhndl)                    // check for error
                    seroutCS(1) ;               // 1 show error
                    seroutCS(cmd) ;             // echo command code to assist the master
                else
                    seroutCS(5) ;               // response is 4 bytes
                    seroutCS(cmd) ;             // echo command code to assist the master
                    file_Size(myhndl,&szh, &szl) ;
                    file_Close(myhndl) ;
                    seroutCS(szh >> 8);
                    seroutCS(szh);
                    seroutCS(szl >> 8);
                    seroutCS(szl);
                endif
                break ;
            default :
                print("Invalid command") ;
                break ;
        endswitch
        seroutOcs() ;
        serout(ACK) ;    // send back an ACK to command, do this last, otherwise the master may send the
                         // next command which is cannot be started until this is finished.
    endif
endfunc
